diff -uNrd ircd-ratbox-1.3-1/autoconf/configure.in ircd-ratbox-1.3-1+fr-ssl/autoconf/configure.in
--- ircd-ratbox-1.3-1/autoconf/configure.in	Wed Oct 15 11:06:56 2003
+++ ircd-ratbox-1.3-1+fr-ssl/autoconf/configure.in	Sat Jan 24 20:39:36 2004
@@ -394,7 +394,7 @@
                 cf_openssl_ciphers="${cf_openssl_ciphers}DES/56 ")
         fi
         CPPFLAGS="$save_CPPFLAGS"
-        SSL_LIBS="$SSL_LIBS -lcrypto"
+        SSL_LIBS="$SSL_LIBS -lcrypto -lssl"
     else
         AC_MSG_RESULT(no - OpenSSL support disabled)
     fi
@@ -495,11 +495,11 @@
 [
   case "$enableval" in
   yes)
-    echo "Forcing poll() to be enabled"
+    dnl echo "Forcing poll() to be enabled"
     ac_cv_func_poll="yes"
     ;;
   no)
-    echo "Forcing poll() to be disabled"
+    dnl echo "Forcing poll() to be disabled"
     ac_cv_func_poll="no"
     ;;
   esac
@@ -512,11 +512,11 @@
 [
   case "$enableval" in
   yes)
-    echo "Forcing select() to be enabled"
+    dnl echo "Forcing select() to be enabled"
     ac_cv_func_select="yes"
     ;;
   no)
-    echo "Forcing select() to be disabled"
+    dnl echo "Forcing select() to be disabled"
     ac_cv_func_select="no"
     ;;
   esac
@@ -529,11 +529,11 @@
 [
   case "$enableval" in
   yes)
-    echo "Forcing kqueue() to be enabled"
+    dnl echo "Forcing kqueue() to be enabled"
     ac_cv_func_kqueue="yes"
     ;;
   no)
-    echo "Forcing kqueue() to be disabled"
+    dnl echo "Forcing kqueue() to be disabled"
     ac_cv_func_kqueue="no"
   ;;
 esac
@@ -546,11 +546,11 @@
 [
   case "$enableval" in
   yes)
-    echo "Forcing /dev/poll to be enabled"
+    dnl echo "Forcing /dev/poll to be enabled"
     ac_cv_func_devpoll="yes"
     ;;
   no)
-    echo "Forcing /dev/poll to be disabled"
+    dnl echo "Forcing /dev/poll to be disabled"
     ac_cv_func_devpoll="no"
   ;;
 esac
@@ -563,7 +563,7 @@
 [
   case "$enableval" in
   yes)
-    echo "Forcing Linux epoll to be enabled"
+    dnl echo "Forcing Linux epoll to be enabled"
     ac_cv_func_epoll="yes"
     ;;
   no)
@@ -622,12 +622,12 @@
                 AC_DEFINE(USE_SELECT)
 	fi
 fi
-echo "Using ${SELECT_TYPE} for select loop."
+dnl echo "Using ${SELECT_TYPE} for select loop."
 AC_DEFINE_UNQUOTED(SELECT_TYPE, "$SELECT_TYPE")
 AC_SUBST(SELECT_SRC)
 
 if test "$ac_cv_func_gettext" = "yes" -o "$ac_cv_lib_intl_gettext" = "yes"; then
-	echo "Building with gettext."
+	dnl echo "Building with gettext."
 	MSGFMT="msgfmt -o"
 	SUBDIR_MESSAGES="messages"
         AC_DEFINE(HAVE_GETTEXT)
@@ -644,7 +644,7 @@
 
 if test "$ac_cv_ipv6" = "yes" ; then
 	AC_DEFINE(IPV6)
-	echo "Using IPv6 support"
+	dnl echo "Using IPv6 support"
 fi
 
 ac_cv_assert="-DNDEBUG"
@@ -713,11 +713,12 @@
 [
   case "$enableval" in
   yes)
-    echo "Enabling small net code."
+    dnl echo "Enabling small net code."
     IRC_CFLAGS="$IRC_CFLAGS -DSMALL_NET=1"
+	ac_cv_smallnet='yes'
     ;;
   no)
-    echo "Disabling small net code."
+    dnl echo "Disabling small net code."
     IRC_CFLAGS="$IRC_CFLAGS"
     ;;
   esac
@@ -732,14 +733,14 @@
 [  --with-nicklen=LENGTH        Set the nick length to LENGTH. ],
 
 [
-	echo $withval
+dnl	echo $withval
   if test "$withval" = "no"; then
 	ac_cv_nicklen="9"
   else
 	ac_cv_nicklen="$withval"
   fi
 ])
-AC_MSG_RESULT("Setting NICKLEN to $ac_cv_nicklen")
+dnl AC_MSG_RESULT("Setting NICKLEN to $ac_cv_nicklen")
 AC_DEFINE_UNQUOTED(NICKLEN, (${ac_cv_nicklen}+1))
 
 dnl Max support clients
@@ -753,7 +754,7 @@
 	ac_cv_maxclients="$withval"
   fi
 ])
-AC_MSG_RESULT("Setting MAX_CLIENTS to $ac_cv_maxclients")
+dnl AC_MSG_RESULT("Setting MAX_CLIENTS to $ac_cv_maxclients")
 AC_DEFINE_UNQUOTED(MAX_CLIENTS, ${ac_cv_maxclients})
 
 dnl Max support clients
@@ -767,7 +768,7 @@
 	ac_cv_topiclen="$withval"
   fi
 ])
-AC_MSG_RESULT("Setting TOPICLEN to $ac_cv_topiclen")
+dnl AC_MSG_RESULT("Setting TOPICLEN to $ac_cv_topiclen")
 AC_DEFINE_UNQUOTED(TOPICLEN, ${ac_cv_topiclen})
 
 dnl shared-modules
@@ -980,12 +981,48 @@
  help/Makefile                  \
 )
 
-if test "X${cf_openssl_ciphers}" != "X"; then
-  echo ""
-  echo "Available cryptlinks ciphers:"
-  echo ""
-  echo "${cf_openssl_ciphers}"
-  echo ""
+dnl if test "X${cf_openssl_ciphers}" != "X"; then
+dnl  echo ""
+dnl  echo "Available cryptlinks ciphers:"
+dnl  echo ""
+dnl  echo "${cf_openssl_ciphers}"
+dnl  echo ""
+dnl fi
+
+echo "
+
+Configuration:
+
+  Installing into ......... $prefix
+  Detected OS ............. `uname -rs`
+  Building Version ........ ${PACKAGE} ${VERSION}
+"
+
+if test "x$ac_cv_ipv6" = "xyes" ; then
+  echo "  IPv6 Support ............ yes"
+else
+  echo "  IPv6 Support ............ no"
 fi
 
-AC_MSG_RESULT(Server is configured with NICKLEN=$ac_cv_nicklen and MAX_CLIENTS=$ac_cv_maxclients)
+if test "x$ac_cv_smallnet" = "xyes" ; then
+  echo "  Small net ............... yes"
+else
+  echo "  Small net ............... no"
+fi
+
+if test "$ac_cv_func_gettext" = "yes" -o "$ac_cv_lib_intl_gettext" = "yes"; then
+  echo "  Gettext ................. yes"
+else
+  echo "  Gettext ................. no"
+fi
+
+echo "
+  Select loop ............. ${SELECT_TYPE}
+  NICKLEN ................. $ac_cv_nicklen
+  TOPICLEN ................ $ac_cv_topiclen
+  MAX_CLIENTS ............. $ac_cv_maxclients
+  Available ciphers ....... ${cf_openssl_ciphers}
+
+"
+
+dnl AC_MSG_RESULT(Server is configured with NICKLEN=$ac_cv_nicklen and MAX_CLIENTS=$ac_cv_maxclients)
diff -uNrd ircd-ratbox-1.3-1/doc/example.conf ircd-ratbox-1.3-1+fr-ssl/doc/example.conf
--- ircd-ratbox-1.3-1/doc/example.conf	Wed Nov  5 09:10:49 2003
+++ ircd-ratbox-1.3-1+fr-ssl/doc/example.conf	Sat Jan 24 19:23:36 2004
@@ -84,6 +84,23 @@
 	 *	chmod 0644 rsa.pub
 	 */
 	#rsa_private_key_file = "/usr/local/ircd/etc/rsa.key";
+
+    /* SSL certificate file, used for client SSL connections
+     *
+     * Assuming your private RSA key is stored in rsa.key, you
+     * must first create a certificate request, then sign it:
+     *
+     *  openssl req -new -key rsa.key -out cert.csr
+     *  openssl x509 -req -in cert.csr -extensions v3_ca \
+     *   -signkey rsa.key -out cert.pem -trustout
+     */
+    #ssl_certificate_file = "/usr/local/ircd/etc/cert.pem";
+
+    /* Certification Authority certificate file, used to sign
+     * ssl_certificate_file. Shouldn't be used if certificate
+     * is self-signed
+     */
+    #ssl_ca_certificate_file = "/usr/local/ircd/etc/ca.pem";
 };
 
 /* admin {}: contains admin information about the server. (OLD A:) */
@@ -195,14 +212,19 @@
 	/* port: listen on all available IPs, ports 5000 and 6665 to 6669 */
 	port = 5000, 6665 .. 6669;
 
+	/* sslport: listen for SSL connections on all available IPs, ports 7000 to 7005 */
+	sslport = 7000 .. 7005;
+
 	/* host: set a specific IP/host the ports after the line will listen 
 	 * on.  This may be ipv4 or ipv6.
 	 */
 	host = "1.2.3.4";
 	port = 7000, 7001;
+	sslport = 7099;
 
 	host = "3ffe:1234:a:b:c::d";
-        port = 7002;
+    port = 7002;
+	sslport = 7199;
 };
 
 /* auth {}: allow users to connect to the ircd (OLD I:) */
diff -uNrd ircd-ratbox-1.3-1/include/client.h ircd-ratbox-1.3-1+fr-ssl/include/client.h
--- ircd-ratbox-1.3-1/include/client.h	Thu Nov 27 13:20:10 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/client.h	Sat Jan 24 19:25:11 2004
@@ -132,6 +132,10 @@
 	unsigned char handler;	/* Handler index */
 	unsigned long serial;	/* used to enforce 1 send per nick */
 
+#ifdef HAVE_LIBCRYPTO
+	SSL *ssl;
+#endif
+
 	/* client->name is the unique name for a client nick or host */
 	char name[HOSTLEN + 1];
 
@@ -164,6 +168,7 @@
 	dlink_list on_allow_list;	/* clients that have =me= on their allow list */
 
 	struct LocalUser *localClient;
+
 };
 
 struct LocalUser
@@ -418,6 +423,7 @@
 #define FLAGS2_IP_SPOOFING      0x400000
 #define FLAGS2_FLOODDONE        0x800000
 #define FLAGS2_EXEMPTSPAMBOT	0x1000000
+#define FLAGS2_SSL				0x2000000
 
 #define SEND_UMODES  (UMODE_INVISIBLE | UMODE_OPER | UMODE_WALLOP | \
                       UMODE_ADMIN)
@@ -540,6 +546,9 @@
 
 #define IsFloodDone(x)          ((x)->flags2 & FLAGS2_FLOODDONE)
 #define SetFloodDone(x)         ((x)->flags2 |= FLAGS2_FLOODDONE)
+
+#define SetSSL(x)               ((x)->flags2 |= FLAGS2_SSL)
+#define IsSSL(x)                (((x)->flags2 & FLAGS2_SSL) && (x)->ssl)
 
 /*
  * definitions for get_client_name
diff -uNrd ircd-ratbox-1.3-1/include/db.h ircd-ratbox-1.3-1+fr-ssl/include/db.h
--- ircd-ratbox-1.3-1/include/db.h	Wed Dec 31 17:00:00 1969
+++ ircd-ratbox-1.3-1+fr-ssl/include/db.h	Sat Jan 24 14:08:29 2004
@@ -0,0 +1,69 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  dh.h: Diffie-Hellman key exchange header.
+ *
+ *  Copyright (C) 2003 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: dh.h,v 1.0 2003/12/03 20:17:11 Sakura Exp $
+ */
+
+#ifndef INCLUDED_dh_h
+#define INCLUDED_dh_h
+
+#include "setup.h"
+
+#ifdef HAVE_LIBCRYPTO
+#include "client.h"
+
+#define KEY_BITS 512
+
+#define RAND_BITS KEY_BITS
+#define RAND_BYTES (RAND_BITS / 8)
+#define RAND_BYTES_HEX ((RAND_BYTES * 2) + 1)
+
+#define PRIME_BITS 1024
+#define PRIME_BYTES (PRIME_BITS / 8)
+#define PRIME_BYTES_HEX ((PRIME_BYTES * 2) + 1)
+
+struct dh_session {
+   DH *dh;
+   char *session_shared;
+   int session_shared_length;
+};
+
+void dh_init(void);
+extern int dh_generate_shared(struct dh_session *, char *);
+extern int dh_get_s_shared(char *, int *, struct dh_session *);
+extern int dh_hexstr_to_raw(char *, unsigned char *, int *);
+extern void dh_end_session(struct dh_session *);
+extern struct dh_session *dh_start_session(void);
+extern char *dh_get_s_secret(char *, int, struct dh_session *);
+extern char *dh_get_s_public(char *, int, struct dh_session *);
+
+extern int safe_SSL_read(struct Client *, void *, int);
+extern int safe_SSL_write(struct Client *, const void *, int);
+extern int safe_SSL_accept(struct Client *, int);
+extern int SSL_smart_shutdown(SSL *);
+extern int initssl(void);
+extern SSL_CTX *ircdssl_ctx;
+
+#endif
+
+extern void ircd_init_ssl(void);
+
+#endif  /* INCLUDED_dh_h */
diff -uNrd ircd-ratbox-1.3-1/include/linebuf.h ircd-ratbox-1.3-1+fr-ssl/include/linebuf.h
--- ircd-ratbox-1.3-1/include/linebuf.h	Thu Jun 26 07:01:41 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/linebuf.h	Sat Jan 24 20:18:31 2004
@@ -80,7 +80,7 @@
 extern int linebuf_parse(buf_head_t *, char *, int, int);
 extern int linebuf_get(buf_head_t *, char *, int, int, int);
 extern void linebuf_putmsg(buf_head_t *, const char *, va_list *, const char *, ...);
-extern int linebuf_flush(int, buf_head_t *);
+extern int linebuf_flush(struct Client *, int, buf_head_t *);
 extern void linebuf_attach(buf_head_t *, buf_head_t *);
 extern void count_linebuf_memory(int *, u_long *);
 #endif
diff -uNrd ircd-ratbox-1.3-1/include/listener.h ircd-ratbox-1.3-1+fr-ssl/include/listener.h
--- ircd-ratbox-1.3-1/include/listener.h	Thu Jun 26 07:01:41 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/listener.h	Sat Jan 24 13:34:18 2004
@@ -48,9 +48,11 @@
 	struct irc_inaddr addr;	/* virtual address or INADDR_ANY */
 	struct DNSQuery *dns_query;
 	char vhost[HOSTLEN + 1];	/* virtual name of listener */
+
+	int	is_ssl;
 };
 
-extern void add_listener(int port, const char *vaddr_ip);
+extern void add_listener(int port, const char *vaddr_ip, int is_ssl);
 extern void close_listener(struct Listener *listener);
 extern void close_listeners(void);
 extern const char *get_listener_name(const struct Listener *listener);
diff -uNrd ircd-ratbox-1.3-1/include/numeric.h ircd-ratbox-1.3-1+fr-ssl/include/numeric.h
--- ircd-ratbox-1.3-1/include/numeric.h	Sun Oct 12 05:50:43 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/numeric.h	Sat Jan 24 19:50:54 2004
@@ -117,6 +117,8 @@
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
 
+#define RPL_USINGSSL	     275
+
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
 
diff -uNrd ircd-ratbox-1.3-1/include/patchlevel.h ircd-ratbox-1.3-1+fr-ssl/include/patchlevel.h
--- ircd-ratbox-1.3-1/include/patchlevel.h	Fri Jan  9 13:05:13 2004
+++ ircd-ratbox-1.3-1+fr-ssl/include/patchlevel.h	Sat Jan 24 20:37:47 2004
@@ -1,10 +1,11 @@
 /*
- *  ircd-ratbox: A slightly useful ircd. 
+ *  FreeWorld-ircd: A slightly useful ircd. 
  *  patchlevel.h: A header defining the patchlevel.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
  *  Copyright (C) 2002 ircd-ratbox development team
+ *  Copyright (C) 2004 FreeWorld development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -25,5 +26,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "ircd-ratbox-1.3-1"
+#define PATCHLEVEL   "ircd-ratbox-1.3-1+SSL"
 #endif
diff -uNrd ircd-ratbox-1.3-1/include/s_conf.h ircd-ratbox-1.3-1+fr-ssl/include/s_conf.h
--- ircd-ratbox-1.3-1/include/s_conf.h	Fri Dec 19 10:32:49 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/s_conf.h	Sat Jan 24 19:25:58 2004
@@ -32,6 +32,7 @@
 
 #ifdef HAVE_LIBCRYPTO
 #include <openssl/rsa.h>
+#include <openssl/ssl.h>
 #endif
 
 #include "config.h"		/* defines */
@@ -84,6 +85,10 @@
 	char *rsa_public_key_file;
 	RSA *rsa_public_key;
 	struct EncCapability *cipher_preference;
+	char *ssl_certificate_file;
+	char *ssl_ca_certificate_file;
+	SSL_CTX *ctx;
+	SSL_METHOD *meth;
 #endif
 };
 
@@ -305,6 +310,10 @@
 #ifdef HAVE_LIBCRYPTO
 	char *rsa_private_key_file;
 	RSA *rsa_private_key;
+  char *ssl_certificate_file;
+  char *ssl_ca_certificate_file;
+  SSL_CTX *ctx;
+  SSL_METHOD *meth;
 #endif
 	int hub;
 	struct irc_inaddr ip;
diff -uNrd ircd-ratbox-1.3-1/include/stdinc.h ircd-ratbox-1.3-1+fr-ssl/include/stdinc.h
--- ircd-ratbox-1.3-1/include/stdinc.h	Wed Oct 15 09:33:59 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/stdinc.h	Sat Jan 24 12:44:26 2004
@@ -48,6 +48,17 @@
 #include <stddef.h>
 #endif
 
+#ifdef HAVE_LIBCRYPTO
+#include <openssl/rand.h>
+#include <openssl/err.h>
+#include <openssl/bn.h>
+#include <openssl/dh.h>
+#include <openssl/rsa.h> 
+#include <openssl/crypto.h>
+#include <openssl/pem.h>
+#include <openssl/ssl.h>
+#endif
+
 
 
 #include <stdio.h>
diff -uNrd ircd-ratbox-1.3-1/include/supported.h ircd-ratbox-1.3-1+fr-ssl/include/supported.h
--- ircd-ratbox-1.3-1/include/supported.h	Mon Aug  4 12:35:23 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/supported.h	Sat Jan 24 19:28:39 2004
@@ -63,7 +63,7 @@
 		  " CHARSET=ascii" \
 		  " CALLERID" \
 		  " ETRACE" \
-		  " WALLCHOPS"
+		  " SSL WALLCHOPS"
 
 #define FEATURES2VALUES ConfigServerHide.disable_local_channels ? "#" : "#&", \
                         ConfigChannel.use_except ? "e" : "", \
diff -uNrd ircd-ratbox-1.3-1/include/tools.h ircd-ratbox-1.3-1+fr-ssl/include/tools.h
--- ircd-ratbox-1.3-1/include/tools.h	Thu Jun 26 07:01:42 2003
+++ ircd-ratbox-1.3-1+fr-ssl/include/tools.h	Sat Jan 24 14:00:28 2004
@@ -63,6 +63,7 @@
 void dlinkAddTail(void *data, dlink_node * m, dlink_list * list);
 
 void dlinkDelete(dlink_node * m, dlink_list * list);
+extern void dlinkDeleteNode(dlink_node *m, dlink_list *list);
 
 void dlinkMoveList(dlink_list * from, dlink_list * to);
 
diff -uNrd ircd-ratbox-1.3-1/modules/m_whois.c ircd-ratbox-1.3-1+fr-ssl/modules/m_whois.c
--- ircd-ratbox-1.3-1/modules/m_whois.c	Fri Nov 28 08:14:51 2003
+++ ircd-ratbox-1.3-1+fr-ssl/modules/m_whois.c	Sat Jan 24 20:32:10 2004
@@ -319,7 +319,13 @@
 	else
 		sendto_one(source_p, form_str(RPL_WHOISSERVER),
 			   me.name, source_p->name, target_p->name,
-			   ServerInfo.network_name, ServerInfo.network_desc);
+		   ServerInfo.network_name, ServerInfo.network_desc);
+
+#ifdef HAVE_LIBCRYPTO
+    if (target_p->ssl)
+      sendto_one(source_p, form_str(RPL_USINGSSL),
+                 me.name, source_p->name, target_p->name);	
+#endif
 
 	if(target_p->user->away)
 		sendto_one(source_p, form_str(RPL_AWAY), me.name,
diff -uNrd ircd-ratbox-1.3-1/src/dh.c ircd-ratbox-1.3-1+fr-ssl/src/dh.c
--- ircd-ratbox-1.3-1/src/dh.c	Wed Dec 31 17:00:00 1969
+++ ircd-ratbox-1.3-1+fr-ssl/src/dh.c	Sat Jan 24 14:16:42 2004
@@ -0,0 +1,247 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  dh.c: Diffie-Hellman key exchange.
+ *
+ *  Copyright (C) 2003 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: dh.c,v 1.00 2003/12/03 20:33:17 Sakura Exp $
+ */
+
+
+#include "stdinc.h"
+#include "setup.h"
+#include "config.h"
+#include "memory.h"
+
+#ifdef HAVE_LIBCRYPTO
+#include "db.h"
+
+static unsigned int dh_gen_1024;
+static unsigned char dh_prime_1024[];
+static char *hex_to_string[256];
+
+static BIGNUM *ircd_prime;
+static BIGNUM *ircd_generator;
+
+static int verify_is_hex(char *string)
+{
+    int l = strlen(string);
+    char tmp[4] = { '\0', '\0', '\0', '\0' };
+    int tmpidx = 0;
+
+    if (l & 0x01) {		/* check if it's odd length */
+	l++;
+	tmp[tmpidx++] = '0';	/* pad with zero */
+    }
+
+    while (*string) {
+	tmp[tmpidx++] = *string++;
+	if (tmpidx == 2) {
+    char *eptr;
+    unsigned char x;
+
+	    tmpidx = 0;
+
+	    x = strtol(tmp, &eptr, 16);
+	    if (*eptr != '\0') {
+		return 0;
+	    }
+	}
+    }
+    return 1;
+}
+
+static void create_prime()
+{
+char buf[PRIME_BYTES_HEX];
+int i;
+int bufpos = 0;
+
+    for (i = 0; i < PRIME_BYTES; i++) {
+char *x = hex_to_string[dh_prime_1024[i]];
+	while (*x)
+	    buf[bufpos++] = *x++;
+    }
+    buf[bufpos] = '\0';
+
+    ircd_prime = NULL;
+    BN_hex2bn(&ircd_prime, buf);
+    ircd_generator = BN_new();
+    BN_set_word(ircd_generator, dh_gen_1024);
+}
+
+void dh_init(void)
+{
+    ERR_load_crypto_strings();
+
+    printf("Importing prime...\n");
+    create_prime();
+    printf("Prime imported.\n");
+}
+
+int dh_generate_shared(struct dh_session *si, char *public_key)
+{
+    BIGNUM *tmp;
+    int len;
+
+    if (verify_is_hex(public_key) == 0 || !si || si->session_shared)
+	return 0;
+
+    tmp = NULL;
+    BN_hex2bn(&tmp, public_key);
+    if (!tmp)
+	return 0;
+
+    si->session_shared_length = DH_size(si->dh);
+    si->session_shared = (char *) MyMalloc(DH_size(si->dh));
+    len = DH_compute_key(si->session_shared, tmp, si->dh);
+    BN_free(tmp);
+
+    if (len < 0)
+	return 0;
+
+    si->session_shared_length = len;
+
+    return 1;
+}
+
+struct dh_session *dh_start_session(void)
+{
+    struct dh_session *si = (struct dh_session *) MyMalloc(sizeof(struct dh_session));
+    if (!si)
+	abort();
+
+    memset(si, 0, sizeof(struct dh_session));
+
+    si->dh = DH_new();
+    si->dh->p = BN_dup(ircd_prime);
+    si->dh->g = BN_dup(ircd_generator);
+
+    if (!DH_generate_key(si->dh)) {
+	DH_free(si->dh);
+	MyFree(si);
+	return NULL;
+    }
+
+    return (void *) si;
+}
+
+void dh_end_session(struct dh_session *si)
+{
+    if (si->dh) {
+	DH_free(si->dh);
+	si->dh = NULL;
+    }
+
+    if (si->session_shared) {
+	memset(si->session_shared, 0, si->session_shared_length);
+	MyFree(si->session_shared);
+	si->session_shared = NULL;
+    }
+
+    MyFree(si);
+}
+
+char *dh_get_s_public(char *buf, int maxlen, struct dh_session *si)
+{
+    char *tmp;
+
+    if (!si || !si->dh || !si->dh->pub_key)
+	return NULL;
+
+    tmp = BN_bn2hex(si->dh->pub_key);
+    if (!tmp)
+	return NULL;
+
+    if (strlen(tmp) + 1 > maxlen) {
+	OPENSSL_free(tmp);
+	return NULL;
+    }
+    strcpy(buf, tmp);
+    OPENSSL_free(tmp);
+
+    return buf;
+}
+
+int dh_get_s_shared(char *buf, int *maxlen, struct dh_session *si)
+{
+    if (!si || !si->session_shared || *maxlen < si->session_shared_length)
+	return 0;
+
+    *maxlen = si->session_shared_length;
+    memcpy(buf, si->session_shared, *maxlen);
+
+    return 1;
+}
+
+static char *hex_to_string[256] = {
+    "00", "01", "02", "03", "04", "05", "06", "07",
+    "08", "09", "0a", "0b", "0c", "0d", "0e", "0f",
+    "10", "11", "12", "13", "14", "15", "16", "17",
+    "18", "19", "1a", "1b", "1c", "1d", "1e", "1f",
+    "20", "21", "22", "23", "24", "25", "26", "27",
+    "28", "29", "2a", "2b", "2c", "2d", "2e", "2f",
+    "30", "31", "32", "33", "34", "35", "36", "37",
+    "38", "39", "3a", "3b", "3c", "3d", "3e", "3f",
+    "40", "41", "42", "43", "44", "45", "46", "47",
+    "48", "49", "4a", "4b", "4c", "4d", "4e", "4f",
+    "50", "51", "52", "53", "54", "55", "56", "57",
+    "58", "59", "5a", "5b", "5c", "5d", "5e", "5f",
+    "60", "61", "62", "63", "64", "65", "66", "67",
+    "68", "69", "6a", "6b", "6c", "6d", "6e", "6f",
+    "70", "71", "72", "73", "74", "75", "76", "77",
+    "78", "79", "7a", "7b", "7c", "7d", "7e", "7f",
+    "80", "81", "82", "83", "84", "85", "86", "87",
+    "88", "89", "8a", "8b", "8c", "8d", "8e", "8f",
+    "90", "91", "92", "93", "94", "95", "96", "97",
+    "98", "99", "9a", "9b", "9c", "9d", "9e", "9f",
+    "a0", "a1", "a2", "a3", "a4", "a5", "a6", "a7",
+    "a8", "a9", "aa", "ab", "ac", "ad", "ae", "af",
+    "b0", "b1", "b2", "b3", "b4", "b5", "b6", "b7",
+    "b8", "b9", "ba", "bb", "bc", "bd", "be", "bf",
+    "c0", "c1", "c2", "c3", "c4", "c5", "c6", "c7",
+    "c8", "c9", "ca", "cb", "cc", "cd", "ce", "cf",
+    "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7",
+    "d8", "d9", "da", "db", "dc", "dd", "de", "df",
+    "e0", "e1", "e2", "e3", "e4", "e5", "e6", "e7",
+    "e8", "e9", "ea", "eb", "ec", "ed", "ee", "ef",
+    "f0", "f1", "f2", "f3", "f4", "f5", "f6", "f7",
+    "f8", "f9", "fa", "fb", "fc", "fd", "fe", "ff"
+};
+
+static unsigned int dh_gen_1024 = 2;
+static unsigned char dh_prime_1024[] = {
+    0xF4, 0x88, 0xFD, 0x58, 0x4E, 0x49, 0xDB, 0xCD,
+    0x20, 0xB4, 0x9D, 0xE4, 0x91, 0x07, 0x36, 0x6B,
+    0x33, 0x6C, 0x38, 0x0D, 0x45, 0x1D, 0x0F, 0x7C,
+    0x88, 0xB3, 0x1C, 0x7C, 0x5B, 0x2D, 0x8E, 0xF6,
+    0xF3, 0xC9, 0x23, 0xC0, 0x43, 0xF0, 0xA5, 0x5B,
+    0x18, 0x8D, 0x8E, 0xBB, 0x55, 0x8C, 0xB8, 0x5D,
+    0x38, 0xD3, 0x34, 0xFD, 0x7C, 0x17, 0x57, 0x43,
+    0xA3, 0x1D, 0x18, 0x6C, 0xDE, 0x33, 0x21, 0x2C,
+    0xB5, 0x2A, 0xFF, 0x3C, 0xE1, 0xB1, 0x29, 0x40,
+    0x18, 0x11, 0x8D, 0x7C, 0x84, 0xA7, 0x0A, 0x72,
+    0xD6, 0x86, 0xC4, 0x03, 0x19, 0xC8, 0x07, 0x29,
+    0x7A, 0xCA, 0x95, 0x0C, 0xD9, 0x96, 0x9F, 0xAB,
+    0xD0, 0x0A, 0x50, 0x9B, 0x02, 0x46, 0xD3, 0x08,
+    0x3D, 0x66, 0xA4, 0x5D, 0x41, 0x9F, 0x9C, 0x7C,
+    0xBD, 0x89, 0x4B, 0x22, 0x19, 0x26, 0xBA, 0xAB,
+    0xA2, 0x5E, 0xC3, 0x55, 0xE9, 0x2F, 0x78, 0xC7
+};
+
+#endif
diff -uNrd ircd-ratbox-1.3-1/src/ircd.c ircd-ratbox-1.3-1+fr-ssl/src/ircd.c
--- ircd-ratbox-1.3-1/src/ircd.c	Fri Nov 28 08:36:49 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/ircd.c	Sat Jan 24 13:27:44 2004
@@ -75,7 +75,7 @@
 #include "newconf.h"
 #include "patricia.h"
 #include "reject.h"
-
+#include "db.h"
 
 /*
  * Try and find the correct name to use with getrlimit() for setting the max.
@@ -582,6 +582,22 @@
 		fprintf(stderr, "Unable to chdir to %s: %s\n", ConfigFileEntry.dpath, strerror(errno));
 		exit(EXIT_FAILURE);
 	}
+
+#ifdef HAVE_LIBCRYPTO
+  dh_init();
+  fprintf(stderr, "SSL: Initialize\n");
+
+  SSL_load_error_strings();
+  SSLeay_add_ssl_algorithms();
+  ServerInfo.ctx = SSL_CTX_new(SSLv23_server_method());
+
+  if (!ServerInfo.ctx) {
+       ERR_print_errors_fp(stderr);
+       return 0;
+  }
+
+  fprintf(stderr, "SSL: Client based SSL connections are enabled.\n");
+#endif
 
 	setup_signals();
 
diff -uNrd ircd-ratbox-1.3-1/src/linebuf.c ircd-ratbox-1.3-1+fr-ssl/src/linebuf.c
--- ircd-ratbox-1.3-1/src/linebuf.c	Fri Jan  9 12:58:49 2004
+++ ircd-ratbox-1.3-1+fr-ssl/src/linebuf.c	Sat Jan 24 20:22:29 2004
@@ -618,7 +618,7 @@
  */
 #undef HAVE_WRITEV
 int
-linebuf_flush(int fd, buf_head_t * bufhead)
+linebuf_flush(struct Client *client_p, int fd, buf_head_t * bufhead)
 {
 	buf_line_t *bufline;
 	int retval;
@@ -721,7 +721,14 @@
 	}
 
 	/* Now, try writing data */
+#ifdef HAVE_LIBCRYPTO
+	if (IsSSL(client_p))
+		retval = safe_SSL_write(client_p, bufline->buf + bufhead->writeofs, bufline->len - bufhead->writeofs);
+	else
+		retval = send(fd, bufline->buf + bufhead->writeofs, bufline->len - bufhead->writeofs, 0);
+#else
 	retval = send(fd, bufline->buf + bufhead->writeofs, bufline->len - bufhead->writeofs, 0);
+#endif
 
 	if(retval <= 0)
 		return retval;
diff -uNrd ircd-ratbox-1.3-1/src/listener.c ircd-ratbox-1.3-1+fr-ssl/src/listener.c
--- ircd-ratbox-1.3-1/src/listener.c	Thu Jun 26 07:03:16 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/listener.c	Sat Jan 24 17:02:35 2004
@@ -131,8 +131,7 @@
 		sendto_one(source_p, form_str(RPL_STATSPLINE),
 			   me.name,
 			   source_p->name,
-			   'P',
-			   listener->port,
+			   listener->is_ssl ? 'S' : 'P', listener->port,
 			   IsOperAdmin(source_p) ? listener->name : me.name,
 			   listener->ref_count, (listener->active) ? "active" : "disabled");
 	}
@@ -268,7 +267,7 @@
  * the format "255.255.255.255"
  */
 void
-add_listener(int port, const char *vhost_ip)
+add_listener(int port, const char *vhost_ip, int is_ssl)
 {
 	struct Listener *listener;
 	struct irc_inaddr vaddr;
@@ -299,6 +298,7 @@
 	else
 	{
 		listener = make_listener(port, &vaddr);
+        listener->is_ssl = is_ssl;
 		listener->next = ListenerPollList;
 		ListenerPollList = listener;
 	}
diff -uNrd ircd-ratbox-1.3-1/src/messages.tab ircd-ratbox-1.3-1+fr-ssl/src/messages.tab
--- ircd-ratbox-1.3-1/src/messages.tab	Thu Nov 20 12:44:39 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/messages.tab	Sat Jan 24 19:50:45 2004
@@ -299,7 +299,7 @@
 /* 272 */       NULL,
 /* 273 */       NULL,
 /* 274 */       NULL,
-/* 275 */       NULL,
+/* 275 RPL_USINGSSL, */			":%s 275 %s %s :connected via SSL (secure link)",
 /* 276 */       NULL,
 /* 277 */       NULL,
 /* 278 */       NULL,
diff -uNrd ircd-ratbox-1.3-1/src/newconf.c ircd-ratbox-1.3-1+fr-ssl/src/newconf.c
--- ircd-ratbox-1.3-1/src/newconf.c	Fri Dec 19 10:33:03 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/newconf.c	Sat Jan 24 18:58:44 2004
@@ -401,6 +401,72 @@
 }
 
 static void
+conf_set_serverinfo_ssl_cert (void *data)
+{
+#ifdef HAVE_LIBCRYPTO
+	if (ServerInfo.ctx)
+	{
+		if (ServerInfo.ssl_certificate_file)
+		{
+			MyFree (ServerInfo.ssl_certificate_file);
+			ServerInfo.ssl_certificate_file = NULL;
+		}
+
+		DupString (ServerInfo.ssl_certificate_file, (char *)data);
+
+		if (!ServerInfo.rsa_private_key_file)
+		{
+			conf_report_error ("Ignoring config file entry ssl_certificate -- no rsa_private_key");
+			return;
+		}
+
+		if (SSL_CTX_use_certificate_file(ServerInfo.ctx, ServerInfo.ssl_certificate_file, SSL_FILETYPE_PEM) <= 0)
+		{
+			conf_report_error ("Error using config file entry ssl_certificate -- %s", ERR_error_string(ERR_get_error(), NULL));
+			return;
+		}
+
+		if (SSL_CTX_use_PrivateKey_file(ServerInfo.ctx, ServerInfo.rsa_private_key_file, SSL_FILETYPE_PEM) <= 0)
+		{
+			conf_report_error ("Error using config file entry rsa_private_key -- %s", ERR_error_string(ERR_get_error(), NULL));
+			return;
+		}
+
+		if (!SSL_CTX_check_private_key(ServerInfo.ctx))
+		{
+			conf_report_error ("RSA private key doesn't match the SSL certificate public key!");
+			return;
+		}
+	}
+
+#endif
+
+}
+
+static void
+conf_set_serverinfo_ssl_ca_cert (void *data)
+{
+#ifdef HAVE_LIBCRYPTO
+	if (ServerInfo.ctx)
+	{
+		if (ServerInfo.ssl_ca_certificate_file)
+		{
+			MyFree (ServerInfo.ssl_ca_certificate_file);
+			ServerInfo.ssl_ca_certificate_file = NULL;
+		}
+
+		DupString (ServerInfo.ssl_ca_certificate_file, (char *)data);
+
+		if (ServerInfo.ssl_ca_certificate_file != NULL && SSL_CTX_load_verify_locations(ServerInfo.ctx, ServerInfo.ssl_ca_certificate_file, NULL) != 1)
+		{
+			conf_report_error ("Error using config file entry ssl_ca_certificate -- ");
+			return;
+		}
+	}
+#endif
+}
+
+static void
 conf_set_modules_module(void *data)
 {
 #ifndef STATIC_MODULES
@@ -1052,7 +1118,24 @@
 			continue;
 		}
 
-		add_listener(args->v.number, listener_address);
+		add_listener(args->v.number, listener_address, 0);
+	}
+}
+
+static void
+conf_set_listen_sslport(void *data)
+{
+	conf_parm_t *args = data;
+
+	for (; args; args = args->next)
+	{
+		if((args->type & CF_MTYPE) != CF_INT)
+		{
+			conf_report_error("listener::port argument is not an integer -- ignoring.");
+			continue;
+		}
+
+		add_listener(args->v.number, listener_address, 1);
 	}
 }
 
@@ -2944,6 +3027,8 @@
 	add_conf_item("serverinfo", "vhost", CF_QSTRING, conf_set_serverinfo_vhost);
 	add_conf_item("serverinfo", "vhost6", CF_QSTRING, conf_set_serverinfo_vhost6);
 	add_conf_item("serverinfo", "hub", CF_YESNO, conf_set_serverinfo_hub);
+	add_conf_item("serverinfo", "ssl_certificate_file", CF_QSTRING, conf_set_serverinfo_ssl_cert);
+	add_conf_item("serverinfo", "ssl_ca_certificate_file", CF_QSTRING, conf_set_serverinfo_ssl_ca_cert);
 
 	add_top_conf("admin", NULL, NULL);
 	add_conf_item("admin", "name", CF_QSTRING, conf_set_admin_name);
@@ -3002,6 +3087,7 @@
         
 	add_top_conf("listen", conf_begin_listen, conf_end_listen);
 	add_conf_item("listen", "port", CF_INT | CF_FLIST, conf_set_listen_port);
+	add_conf_item("listen", "sslport", CF_INT | CF_FLIST, conf_set_listen_sslport);
 	add_conf_item("listen", "ip", CF_QSTRING, conf_set_listen_address);
 	add_conf_item("listen", "host", CF_QSTRING, conf_set_listen_address);
 
diff -uNrd ircd-ratbox-1.3-1/src/packet.c ircd-ratbox-1.3-1+fr-ssl/src/packet.c
--- ircd-ratbox-1.3-1/src/packet.c	Thu Jun 26 07:03:17 2003
+++ ircd-ratbox-1.3-1+fr-ssl/src/packet.c	Sat Jan 24 19:31:55 2004
@@ -38,6 +38,7 @@
 #include "memory.h"
 #include "hook.h"
 #include "send.h"
+#include "db.h"
 
 static char readBuf[READBUF_SIZE];
 static void client_dopacket(struct Client *client_p, char *buffer, size_t length);
@@ -375,6 +376,11 @@
 	 * I personally think it makes the code too hairy to make sane.
 	 *     -- adrian
 	 */
+#ifdef HAVE_LIBCRYPTO
+  if (IsSSL(client_p))
+    length = safe_SSL_read(client_p, readBuf, READBUF_SIZE);
+  else
+#endif
 	length = recv(fd_r, readBuf, READBUF_SIZE, 0);
 
 	if(length <= 0)
